stacksg    segment  stack
    db 64 dup ("stack----")
stacksg  ends
;*******************************
datasg       segment   para
xbinary      dw        0           ;binary x coordinate
ybinary      dw        0           ;binary y coordinate
ascval       dw        ?           ;ascii field
;*******************************
            ;screen display fields
dispdata    label      byte
xmsg        db         'x=  '      ;x message
xascii      dw         ?
            db         ' '
ymsg        db         ',y= '      ;y message
yascii      dw         ?
datasg      ends
;*******************************
            .286
codesg      segment    para  
main        proc       far
            assume     ss: stacksg, ds:datasg, cs:codesg
            mov        ax, datasg
            mov        ds, ax
            call       clrscr       ;clear screen
            call       makeinit      ;initialize mouse
            cmp        ax, 00h      ;mouse installed?
            je         p3           ;no , exit
p1:       
            call       getptr       ;get mouse pointer
            cmp        bx, 01       ;button pressed?
            je         p2
            call       locate       ;set cursor
            mov        ax, xbinary
            call       convert      ;x to ascii
            mov        ax, ascval
            mov        xascii, ax
            mov        ax, ybinary
            call       convert      ;y to ascii
            mov        ax, ascval
            mov        yascii, ax
            call       disply       ;display x, y vales
            jmp        p1
p2:
            call       hidemouse    ;hide mouse pointer
p3:         call       clrscr       ;clear screen
            mov        ax, 4c00h    ;end processing
            int        21h
main     endp
;***********initialize mouse pointer  *****
makeinit    proc       near
            mov        ax, 00h
            int        33h
            cmp        ax,00       ;mouse installed?
            je         p4          ;no, exit
            mov        ax, 01h     ;show pointer
            int        33h
p4:
            ret
makeinit    endp
;************ get mouse pointer location *******
getptr      proc       near
p5:         mov        ax, 03h     ;get pointer location
            int        33h
            cmp        bx, 01h     ;left botton pressed?
            je         p6          ;yes means exit
            shr        cx, 03      ;divide pixel vale
            shr        dx, 03      ; by 8
            cmp        cx, xbinary ;has pointer location changed?
            jne        p7          
            cmp        dx, ybinary
            je         p5          ;no, repeat operation
p7:         mov        xbinary, cx ;yes, save new location
            mov        ybinary, dx
p6 :        ret
getptr      endp
;*********** convert  binary to ascii ********
convert     proc       near             ;ax=binar x or y
            mov        ascval, 2020h    ;clear ascii field
            mov        cx, 10           ;set divide factor
            lea        si, ascval + 1   ;load ascii address
            cmp        ax, cx           ;compare location to 10
            jb         p8               ;lower, bypass
            div        cl               ;higer, divide by 10
            or         ah, 30h          ;insert ascii
            mov        [si], ah         ;store in rightmost byte
            dec        si               ;decrement address of ascval
p8:         or         al, 30h          ;insert ascii
            mov        [si], al
            ret
convert     endp
;*************** hide mouse pointer *********
hidemouse   proc       near
            mov        ax, 02h
            int        33h
            ret
hidemouse   endp
;************ screen operation **************
clrscr      proc       near
            mov        ax, 0600h        ;request clear screen
            mov        bh, 30h          ;colors
            mov        cx, 00           ;full
            mov        dx, 184fh        ;screen
            int        10h
            ret
clrscr      endp
;************* move cursor ******************
locate      proc       near
            mov        ah, 02h          ;set cursor
            mov        bh, 0            ;page#=0
            mov        dh, 0            ;row
            mov        dl, 25           ;column
            int        10h
            ret
locate      endp
;*************display data*************
disply      proc       near
            mov        ah, 40h           ;request display
            mov        bx, 01            ;screen handle
            mov        cx, 14            ;number of characters
            lea        dx, dispdata      ;display area
            int        21h
            ret
disply      endp
codesg      ends
            end        main

























































          



















































